diff --git a/lisp/faces.el b/lisp/faces.el
index a8c1546..a61227e 100644
--- a/lisp/faces.el
+++ b/lisp/faces.el
@@ -2502,6 +2502,270 @@ unwanted effects."
   :group 'basic-faces
   :group 'display-line-numbers)
 
+
+;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+;;; begin MULTIPLE CURSORS
+
+(defface +-vertical-bar-face
+  '((t (:foreground "magenta")))
+  "Face for `+-vertical-bar-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-even-numbered-column-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "purple")
+    (((class color) (min-colors 88) (background light))
+     :foreground "purple")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-even-numbered-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-odd-numbered-column-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "red")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "red")
+    (((class color) (min-colors 88) (background light))
+     :foreground "red")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-odd-numbered-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-even-numbered-column-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "#eee8aa")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "purple3")
+    (((class color) (min-colors 88) (background light))
+     :foreground "purple3")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-even-numbered-column-inactive-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-odd-numbered-column-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "#ff6347")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "orange")
+    (((class color) (min-colors 88) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-odd-numbered-column-inactive-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-beyond-fill-column-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "green")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "green")
+    (((class color) (min-colors 88) (background light))
+     :foreground "green")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-beyond-fill-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+
+(defface +-beyond-fill-column-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "#2e8b57")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "#2e8b57")
+    (((class color) (min-colors 88) (background light))
+     :foreground "#2e8b57")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-beyond-fill-column-inactive-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-real-fake-cursor-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "cyan" :background "DarkBlue")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color" :background "gtk_selection_bg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "black" :background "LightSkyBlue")
+    (((class color) (min-colors 88) (background light))
+     :foreground "black" :background "LightSkyBlue")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow" :background "blue3")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange" :background "lightgoldenrod2")
+    (((class color) (min-colors 8))
+     :foreground "white" :background "blue")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink" :background "gray"))
+  "Face for `+-real-fake-cursor-face'.  Used in `xdisp.c'.
+As to a hollow style cursor, the :foreground parameter is used for the border and
+the :background parameter is used for the inner filled shading.  The character
+retains its own foreground color and is unaffected by this particular face."
+  :group '+-mode)
+
+(defface +-real-fake-cursor-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "#ff00ff" :background "ForestGreen")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color" :background "gtk_selection_bg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "black" :background "grey70")
+    (((class color) (min-colors 88) (background light))
+     :foreground "black" :background "grey70")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow" :background "blue3")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange" :background "lightgoldenrod2")
+    (((class color) (min-colors 8))
+     :foreground "white" :background "blue")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink" :background "gray"))
+  "Face for `+-real-fake-cursor-inactive-face'.  Used in `xdisp.c'.
+As to a hollow style cursor, the :foreground parameter is used for the border and
+the :background parameter is used for the inner filled shading.  The character
+retains its own foreground color and is unaffected by this particular face."
+  :group '+-mode)
+
+(defface +-real-fake-cursor-region-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "grey15" :background "#8b795e")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "gtk_selection_fg_color" :background "gtk_selection_bg_color")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "pink" :background "#8b795e")
+    (((class color) (min-colors 88) (background light))
+     :foreground "pink" :background "#8b795e")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow" :background "blue3")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange" :background "lightgoldenrod2")
+    (((class color) (min-colors 8))
+     :foreground "white" :background "blue")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink" :background "gray"))
+  "Face for `+-real-fake-cursor-region-face'.  Used in `xdisp.c'.
+As to a hollow style cursor, the :foreground parameter is used for the inner
+filled shading when PT is _not_ within the active region; and, the :background
+parameter is used for the inner filled shading when PT _is_ within the active
+region.  The character retains its own foreground color and is unaffected by this
+particular face."
+  :group '+-mode)
+
+(defface +-overlay-arrow-face
+  '((t (:foreground "red")))
+  "Face for `+-overlay-arrow-face'."
+  :group '+-mode)
+
+(defface +-overlay-arrow-minimal-face
+  '((t (:foreground "blue")))
+  "Face for `+-overlay-arrow-minimal-face'."
+  :group '+-mode)
+
+(defface +-overlay-arrow-inactive-face
+  '((t (:foreground "DarkSlateGrey")))
+  "Face for `+-overlay-arrow-inactive-face'."
+  :group '+-mode)
+
+(defface +-overlay-arrow-hscl-face
+  '((t (:foreground "DarkGreen")))
+  "Face for `+-overlay-arrow-hscl-face'."
+  :group '+-mode)
+
+(defface +-overlay-arrow-hscl-minimal-face
+  '((t (:foreground "SaddleBrown")))
+  "Face for `+-overlay-arrow-hscl-minimal-face'."
+  :group '+-mode)
+
+(defface +-overlay-arrow-hscl-inactive-face
+  '((t (:foreground "DarkSlateGrey")))
+  "Face for `+-overlay-arrow-hscl-inactive-face'."
+  :group '+-mode)
+
+(defface mc-fill-column-face
+  '((t (:foreground "grey15")))
+  "Face for `mc-fill-column-face' in the active window.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface mc-fill-column-inactive-face
+  '((t (:foreground "DarkBlue")))
+  "Face for `mc-fill-column-inactive-face' in the inactive window.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface mc-fill-column-opoint-face
+  '((t (:foreground "magenta")))
+  "Face for `mc-fill-column-opoint-face' in the active window.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface mc-fill-column-opoint-inactive-face
+  '((t (:foreground "cyan")))
+  "Face for `mc-fill-column-opoint-inactive-face' in the inactive window.  Used in `xdisp.c'."
+  :group '+-mode)
+
+;;; end MULTIPLE CURSORS
+;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+
+
 (defface escape-glyph
   '((((background dark)) :foreground "cyan")
     ;; See the comment in minibuffer-prompt for
diff --git a/src/buffer.c b/src/buffer.c
index 90ef886..7912e5e 100644
--- a/src/buffer.c
+++ b/src/buffer.c
@@ -5097,6 +5097,28 @@ init_buffer_once (void)
   bset_last_selected_window (&buffer_local_flags, make_fixnum (0));
 
   idx = 1;
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_real_fake_cursor), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, multiple_cursors_conf), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, multiple_cursors_draw_forthwith), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, multiple_cursors_inactive_windows), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs_horizontal_ruler), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs_vertical_ruler), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs_draw_forthwith), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs_inactive_windows), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_stderr), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_fill_column), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_fill_column_draw_forthwith), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_fill_column_inactive_windows), idx); ++idx;
+
+/* *************************************************************************** */
+
+
   XSETFASTINT (BVAR (&buffer_local_flags, mode_line_format), idx); ++idx;
   XSETFASTINT (BVAR (&buffer_local_flags, abbrev_mode), idx); ++idx;
   XSETFASTINT (BVAR (&buffer_local_flags, overwrite_mode), idx); ++idx;
@@ -5178,6 +5200,28 @@ init_buffer_once (void)
   /* Must do these before making the first buffer! */
 
   /* real setup is done in bindings.el */
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  bset_blv_mc_real_fake_cursor (&buffer_defaults, Qhollow);
+  bset_blv_multiple_cursors_conf (&buffer_defaults, Qnil);
+  bset_blv_multiple_cursors_draw_forthwith (&buffer_defaults, Qt);
+  bset_blv_multiple_cursors_inactive_windows (&buffer_defaults, Qt);
+  bset_blv_crosshairs (&buffer_defaults, Qnil);
+  bset_blv_crosshairs_horizontal_ruler (&buffer_defaults, Qt);
+  bset_blv_crosshairs_vertical_ruler (&buffer_defaults, Qt);
+  bset_blv_crosshairs_draw_forthwith (&buffer_defaults, Qnil);
+  bset_blv_crosshairs_inactive_windows (&buffer_defaults, Qt);
+  bset_blv_mc_stderr (&buffer_defaults, Qnil);
+  bset_blv_mc_fill_column (&buffer_defaults, Qnil);
+  bset_blv_mc_fill_column_draw_forthwith (&buffer_defaults, Qnil);
+  bset_blv_mc_fill_column_inactive_windows (&buffer_defaults, Qt);
+
+/* *************************************************************************** */
+
+
   bset_mode_line_format (&buffer_defaults, build_pure_c_string ("%-"));
   bset_header_line_format (&buffer_defaults, Qnil);
   bset_abbrev_mode (&buffer_defaults, Qnil);
@@ -5416,6 +5460,27 @@ syms_of_buffer (void)
   staticpro (&QSFundamental);
   staticpro (&Vbuffer_alist);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  DEFSYM (Qmc_real_fake_cursor, "mc-real-fake-cursor");
+  DEFSYM (Qmultiple_cursors_conf, "multiple-cursors-conf");
+  DEFSYM (Qmultiple_cursors_draw_forthwith, "multiple-cursors-draw-forthwith");
+  DEFSYM (Qmultiple_cursors_inactive_windows, "multiple-cursors-inactive-windows");
+  DEFSYM (Qcrosshairs, "crosshairs");
+  DEFSYM (Qcrosshairs_horizontal_ruler, "crosshairs-horizontal-ruler");
+  DEFSYM (Qcrosshairs_vertical_ruler, "crosshairs-vertical-ruler");
+  DEFSYM (Qcrosshairs_draw_forthwith, "crosshairs-draw-forthwith");
+  DEFSYM (Qcrosshairs_inactive_windows, "crosshairs-inactive-windows");
+  DEFSYM (Qmc_stderr, "mc-stderr");
+  DEFSYM (Qmc_fill_column, "mc-fill-column");
+  DEFSYM (Qmc_fill_column_draw_forthwith, "mc-fill-column-draw-forthwith");
+  DEFSYM (Qmc_fill_column_inactive_window, "mc-fill-column-inactive-window");
+
+/* *************************************************************************** */
+
+
   DEFSYM (Qchoice, "choice");
   DEFSYM (Qleft, "left");
   DEFSYM (Qright, "right");
@@ -5453,6 +5518,65 @@ syms_of_buffer (void)
   Fput (Qprotected_field, Qerror_message,
 	build_pure_c_string ("Attempt to modify a protected field"));
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  DEFVAR_PER_BUFFER ("mc-real-fake-cursor", &BVAR (current_buffer, mc_real_fake_cursor), Qnil,
+    doc: /* A bufer-local variable to set the cursor type of the real fake cursor. */);
+
+  DEFVAR_PER_BUFFER ("multiple-cursors-conf", &BVAR (current_buffer, multiple_cursors_conf), Qnil,
+    doc: /* A bufer-local variable to store the value of the multiple cursors to be displayed
+during the next redisplay. */);
+
+  DEFVAR_PER_BUFFER ("multiple-cursors-draw-forthwith", &BVAR (current_buffer, multiple_cursors_draw_forthwith), Qnil,
+    doc: /* When non-nil, draw multiple cursors whenever the real cursor would
+ordinarily be drawn, which is sometimes more than once every command loop.
+When nil, multiple-cursors will be placed on an idle-timer.  If this variable is
+reset while `multiple-cursors-mode' is enabled, then it may be necessary to turn off/on
+`multiple-cursors-mode' to reset functions attached to the `post-command-hook'. */);
+
+  DEFVAR_PER_BUFFER ("multiple-cursors-inactive-windows", &BVAR (current_buffer, multiple_cursors_inactive_windows), Qnil,
+    doc: /* When non-nil, draw multiple cursors in inactive windows. */);
+
+  DEFVAR_PER_BUFFER ("crosshairs", &BVAR (current_buffer, crosshairs), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate crosshairs. */);
+
+  DEFVAR_PER_BUFFER ("crosshairs-horizontal-ruler", &BVAR (current_buffer, crosshairs_horizontal_ruler), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate the crosshairs horizontal ruler. */);
+
+  DEFVAR_PER_BUFFER ("crosshairs-vertical-ruler", &BVAR (current_buffer, crosshairs_vertical_ruler), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate the crosshairs vertical ruler. */);
+
+  DEFVAR_PER_BUFFER ("crosshairs-draw-forthwith", &BVAR (current_buffer, crosshairs_draw_forthwith), Qnil,
+    doc: /* When non-nil, draw crosshairs whenever the real cursor would
+ordinarily be drawn, which is sometimes more than once every command loop.
+When nil, crosshairs will be placed on an idle-timer.  If this variable is
+reset while `+-mode' is enabled, then it may be necessary to turn off/on
+`+-mode' to reset functions attached to the `post-command-hook'. */);
+
+  DEFVAR_PER_BUFFER ("crosshairs-inactive-windows", &BVAR (current_buffer, crosshairs_inactive_windows), Qnil,
+    doc: /* When non-nil, draw crosshairs in inactive windows. */);
+
+  DEFVAR_PER_BUFFER ("mc-stderr", &BVAR (current_buffer, mc_stderr), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate debugging messages to stderr. */);
+
+  DEFVAR_PER_BUFFER ("mc-fill-column", &BVAR (current_buffer, mc_fill_column), Qnil,
+    doc: /* A bufer-local variable to turn on/off the multiple cursors fill column. */);
+
+  DEFVAR_PER_BUFFER ("mc-fill-column-draw-forthwith", &BVAR (current_buffer, mc_fill_column_draw_forthwith), Qnil,
+    doc: /* When non-nil, draw multiple cursors fill column whenever the real cursor would
+ordinarily be drawn, which is sometimes more than once every command loop.
+When nil, the multiple cursors fill column will be placed on an idle-timer.  If this variable
+is reset while `mc-fill-column-mode' is enabled, then it may be necessary to turn off/on
+`mc-fill-column-mode' to reset functions attached to the `post-command-hook'. */);
+
+  DEFVAR_PER_BUFFER ("mc-fill-column-inactive-windows", &BVAR (current_buffer, mc_fill_column_inactive_windows), Qnil,
+    doc: /* When non-nil, draw multiple cursors fill column in inactive windows. */);
+
+/* *************************************************************************** */
+
+
   DEFVAR_PER_BUFFER ("header-line-format",
 		     &BVAR (current_buffer, header_line_format),
 		     Qnil,
diff --git a/src/buffer.h b/src/buffer.h
index 4ea7fa6..2305f47 100644
--- a/src/buffer.h
+++ b/src/buffer.h
@@ -636,6 +636,52 @@ struct buffer
      cache are enabled.  See search.c, indent.c and bidi.c for details.  */
   Lisp_Object cache_long_scans_;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  /* The cursor type of the real fake cursor. */
+  Lisp_Object mc_real_fake_cursor_;
+
+  /* The name of list used by multiple cursors for next redisplay. */
+  Lisp_Object multiple_cursors_conf_;
+
+  /* Whether to draw multiple cursors immediately, or on an idle-timer. */
+  Lisp_Object multiple_cursors_draw_forthwith_;
+
+  /* Whether to draw multiple cursors in inactive windows. */
+  Lisp_Object multiple_cursors_inactive_windows_;
+
+  /* The name of the buffer-local variable. */
+  Lisp_Object crosshairs_;
+
+  /* The name of the crosshairs horizontal ruler. */
+  Lisp_Object crosshairs_horizontal_ruler_;
+
+  /* The name of the crosshairs vertical ruler. */
+  Lisp_Object crosshairs_vertical_ruler_;
+
+  /* Whether to draw crosshairs immediately, or on an idle-timer. */
+  Lisp_Object crosshairs_draw_forthwith_;
+
+  /* Whether to draw crosshairs in inactive windows. */
+  Lisp_Object crosshairs_inactive_windows_;
+
+  /* Used in conjunction with generating stderr debugging message. */
+  Lisp_Object mc_stderr_;
+
+  /* The name of the buffer-local variable. */
+  Lisp_Object mc_fill_column_;
+
+  /* Whether to draw multiple cursors fill column immediately, or on an idle-timer. */
+  Lisp_Object mc_fill_column_draw_forthwith_;
+
+  /* Whether to draw multiple cursors fill column in inactive windows. */
+  Lisp_Object mc_fill_column_inactive_windows_;
+
+/* *************************************************************************** */
+
+
   /* If the width run cache is enabled, this table contains the
      character widths width_run_cache (see above) assumes.  When we
      do a thorough redisplay, we compare this against the buffer's
@@ -792,9 +838,17 @@ struct buffer
      for a buffer-local variable is stored in that variable's slot
      in buffer_local_flags as a Lisp integer.  If the index is -1,
      this means the variable is always local in all buffers.  */
-#define MAX_PER_BUFFER_VARS 50
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+#define MAX_PER_BUFFER_VARS 60
   char local_flags[MAX_PER_BUFFER_VARS];
 
+/* *************************************************************************** */
+
+
   /* Set to the modtime of the visited file when read or written.
      modtime.tv_nsec == NONEXISTENT_MODTIME_NSECS means
      visited file was nonexistent.  modtime.tv_nsec ==
@@ -896,6 +950,92 @@ XBUFFER (Lisp_Object a)
 /* Most code should use these functions to set Lisp fields in struct
    buffer.  (Some setters that are private to a single .c file are
    defined as static in those files.)  */
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+INLINE void
+bset_blv_mc_real_fake_cursor (struct buffer *b, Lisp_Object val)
+{
+  b->mc_real_fake_cursor_ = val;
+}
+
+INLINE void
+bset_blv_multiple_cursors_conf (struct buffer *b, Lisp_Object val)
+{
+  b->multiple_cursors_conf_ = val;
+}
+
+INLINE void
+bset_blv_multiple_cursors_draw_forthwith (struct buffer *b, Lisp_Object val)
+{
+  b->multiple_cursors_draw_forthwith_ = val;
+}
+
+INLINE void
+bset_blv_multiple_cursors_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->multiple_cursors_inactive_windows_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs_horizontal_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_horizontal_ruler_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs_vertical_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_vertical_ruler_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs_draw_forthwith (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_draw_forthwith_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_inactive_windows_ = val;
+}
+
+INLINE void
+bset_blv_mc_stderr (struct buffer *b, Lisp_Object val)
+{
+  b->mc_stderr_ = val;
+}
+
+INLINE void
+bset_blv_mc_fill_column (struct buffer *b, Lisp_Object val)
+{
+  b->mc_fill_column_ = val;
+}
+
+INLINE void
+bset_blv_mc_fill_column_draw_forthwith (struct buffer *b, Lisp_Object val)
+{
+  b->mc_fill_column_draw_forthwith_ = val;
+}
+
+INLINE void
+bset_blv_mc_fill_column_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->mc_fill_column_inactive_windows_ = val;
+}
+
+/* *************************************************************************** */
+
+
 INLINE void
 bset_bidi_paragraph_direction (struct buffer *b, Lisp_Object val)
 {
diff --git a/src/dispextern.h b/src/dispextern.h
index 579665c..b5ee135 100644
--- a/src/dispextern.h
+++ b/src/dispextern.h
@@ -94,6 +94,28 @@ typedef int Cursor;
 #define NativeRectangle int
 #endif
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+enum mc_types
+{
+  NO_FLAVOR,
+  MC_GLYPH,
+  MC_GLYPHLESS,
+  MC_GLYPH_TAB,
+  MC_OVERLAY_ARROW_BITMAP,
+  MC_PILCROW,
+  MC_HOLLOW_RECTANGLE_RIGHT_ARROW,
+  MC_HOLLOW_RECTANGLE,
+  MC_VERTICAL_BAR_RIGHT_ARROW,
+  MC_VERTICAL_BAR,
+  MC_VERTICAL_BAR_BACKSLASH
+};
+
+/* *************************************************************************** */
+
+
 /* Text cursor types.  */
 
 enum text_cursor_kinds
@@ -376,6 +398,18 @@ struct glyph_slice
 
 struct glyph
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  int x, y, hpos, vpos;
+
+  bool_bf zv_p : 1;
+
+/* *************************************************************************** */
+
+
   /* Position from which this glyph was drawn.  If `object' below is a
      Lisp string, this is an index into that string.  If it is a
      buffer, this is a position in that buffer.  In addition, some
@@ -2210,6 +2244,16 @@ struct composition_it
 
 struct it
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  bool_bf zv_p : 1;
+
+/* *************************************************************************** */
+
+
   /* The window in which we iterate over current_buffer (or a string).  */
   Lisp_Object window;
   struct window *w;
diff --git a/src/frame.h b/src/frame.h
index ad7376a..31d9527 100644
--- a/src/frame.h
+++ b/src/frame.h
@@ -202,6 +202,16 @@ struct frame
 
   /* Beyond here, there should be no more Lisp_Object components.  */
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  /* Non-nil when the frame is in the process of being updated. */
+  struct frame *mc_updating_frame;
+
+/* *************************************************************************** */
+
+
   /* Cache of realized faces.  */
   struct face_cache *face_cache;
 
